//Here you can change things

PImage img = loadImage("painting.jpg");// the source image
float gamma=.4;                                  // the amount of nonlinearity to display the historgram. gamma=1 is normal but you may miss low frequency hues-> make it smaller then 1
int bins=100;                                     // the amount of bins in the histogram (number of triangles)

//From here I would not change things



int centerPlotX,centerPlotY;
float hueStepSize=2*PI/bins;
int[] hueHist = new int[bins];
colorMode(HSB,bins,255,255);
img.resize(0,512);
int sideSpace;
if(img.width>img.height){sideSpace=img.height;}else{sideSpace=img.width;}
size(img.width+sideSpace, img.height);
image(img,0,0);
centerPlotX=round(.5*sideSpace+img.width);  //defines where the middle of the histogram is shown
centerPlotY=round(img.height/2);
smooth();
ellipseMode(CENTER);
//histogram calculation:
for (int i = 0; i < img.width; i++) {
  for (int j = 0; j < img.height; j++) {
    int hueValue = floor(hue(get(i, j)));
    int saturationValue = floor(saturation(get(i, j)));
    if (saturationValue>20){    //whites are not so interesting, therefor they are thresholded here...
      hueHist[hueValue]++;
    }
  }
}
int hueHistMax = max(hueHist);
background(0,0,128);

image(img,0,0);
noStroke();
float r0;

for (int i = 0; i < bins; i++) {
  fill(i,255,255);
  if (img.height<img.width){
   r0=img.height;}
   else {
     r0=img.width;}
     
   float hueHistNorm=.6*hueHist[i]/hueHistMax;      //needed the 1.0 to make it a real float apparantly....
   float r=0.5*r0*pow(hueHistNorm,gamma);
   float r2=.45*r0;
   float h=10;
   triangle(centerPlotX,centerPlotY,centerPlotX+r*cos(i*2*PI/bins),centerPlotY+r*sin(i*2*PI/bins),centerPlotX+r*cos(i*2*PI/bins+hueStepSize),centerPlotY+r*sin(i*2*PI/bins+hueStepSize));
   beginShape();
   vertex(centerPlotX+r2*cos(i*2*PI/bins), centerPlotY+r2*sin(i*2*PI/bins));
   vertex(centerPlotX+r2*cos(i*2*PI/bins+hueStepSize), centerPlotY+r2*sin(i*2*PI/bins+hueStepSize));
   vertex(centerPlotX+(r2+h)*cos(i*2*PI/bins+hueStepSize), centerPlotY+(r2+h)*sin(i*2*PI/bins+hueStepSize));
   vertex(centerPlotX+(r2+h)*cos(i*2*PI/bins), centerPlotY+(r2+h)*sin(i*2*PI/bins));
   endShape(CLOSE);

}
